//gun.cs

//audio
datablock AudioProfile(gunShot1Sound)
{
   filename    = "./gunShot1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(bulletHitSound)
{
   filename    = "./bulletHit.wav";
   description = AudioClose3d;
   preload = true;
};






//Shell
datablock DebrisData(gunShellDebris)
{
	shapeFile = "./gunShell.dts";
	lifetime = 3.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};






//Muzzle flash particle
datablock ParticleData(MP40FlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.5;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./MuzzleFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 1.0 0.2 0.6";
	colors[1]     = "1.0 1.0 0.6 0.2";
	sizes[0]      = 0.5;
	sizes[1]      = 1.2;

	useInvAlpha = false;
};





//Muzzle flash emitter
datablock ParticleEmitterData(MP40FlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 5.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MP40FlashParticle";

   uiName = "MP40 Flash";
};





//Muzzle smoke particle
datablock ParticleData(gunSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};





//Muzzle smoke emitter
datablock ParticleEmitterData(gunSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "gunSmokeParticle";

   uiName = "Gun Smoke";
};





//Bullet impact smoke particle
datablock ParticleData(gunExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};





//Bullet impact smoke
datablock ParticleEmitterData(gunExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "gunExplosionParticle";

   useEmitterColors = true;
   uiName = "Gun Hit Dust";
};





//Bullet impact flash particle
datablock ParticleData(MP40ExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "./BulletImpact";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};





//Bullet impact flash
datablock ParticleEmitterData(MP40ExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MP40ExplosionRingParticle";

   useEmitterColors = true;
   uiName = "MP40 Hit Flash";
};





//Bullet impact effects
datablock ExplosionData(MP40Explosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = MP40ExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = MP40ExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};





//Bullet properties
AddDamageType("MP40",   '<bitmap:add-ons/Weapon_MP40/CI_MP40> %1',    '%2 <bitmap:add-ons/Weapon_MP40/CI_MP40> %1',0.2,1);
datablock ProjectileData(MP40Projectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 12;
   directDamageType    = $DamageType::Gun;
   radiusDamageType    = $DamageType::Gun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = MP40Explosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0.3;

   armingDelay         = 00;
   lifetime            = 40000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "MP40 Bullet";
};





//Gun Item
datablock ItemData(MP40Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./MP40.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "MP40";
	iconName = "./Icon_MP40";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = MP40Image;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MP40Image)
{
   // Basic Item properties
   shapeFile = "./MP40.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = MP40Projectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     		= "Activate";
	stateTimeoutValue[0]             		= 0.0;
	stateTransitionOnTimeout[0]       	= "Ready";

	stateName[1]                     		= "Ready";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateSequence[1]			= "Ready";

	stateName[2]                    		= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            		= 0.07;
	stateFire[2]                    		= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                		= "Fire";
	stateScript[2]                  		= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= MP40FlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= gunShot1Sound;
	stateEjectShell[2]       		= true;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]			= 0.05;
	stateEmitterNode[3]		= "muzzleNode";
	stateTimeoutValue[3]            		= 0.01;
	stateTransitionOnTimeout[3]     	= "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                		= "Reload";
	stateTransitionOnTriggerDown[4]     	= "Fire";
	stateTransitionOnTriggerUp[4]     	= "Ready";
	stateSequence[4]			= "Ready";

};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MP40Image2)
{
   // Basic Item properties
   shapeFile = "./MP40.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset="0 0.9 -0.071";
   rotation = eulerToMatrix( "0 0 0" );


   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = MP40Projectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     		= "Activate";
	stateTimeoutValue[0]             		= 0.0;
	stateTransitionOnTimeout[0]       	= "Ready";

	stateName[1]                     		= "Ready";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateSequence[1]			= "Ready";

	stateName[2]                    		= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            		= 0.07;
	stateFire[2]                    		= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                		= "Fire";
	stateScript[2]                  		= "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= MP40FlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= gunShot1Sound;
	stateEjectShell[2]       		= true;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]			= 0.05;
	stateEmitterNode[3]		= "muzzleNode";
	stateTimeoutValue[3]            		= 0.01;
	stateTransitionOnTimeout[3]     	= "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                		= "Reload";
	stateTransitionOnTriggerDown[4]     	= "Fire";
	stateTransitionOnTriggerUp[4]     	= "Ready";
	stateSequence[4]			= "Ready";
};

function MP40Image2::onMount(%this,%obj,%slot)
{
	setFov(30);
}

function MP40Image2::onUnMount(%this,%obj,%slot)
{
	setFov(90);
}

function MP40Image::onFire(%this, %obj, %slot)
{
   %spread = 0.00175;
   %projectile = %this.projectile;
   %vector = %obj.getMuzzleVector(%slot);
   %objectVelocity = %obj.getVelocity();
   %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
   %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
   %velocity = VectorAdd(%vector1,%vector2);
   %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
   %velocity = MatrixMulVector(%mat, %velocity);
   %p = new (%this.projectileType)()
   {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
   };
   MissionCleanup.add(%p);
}




package imageSwitch
{
	function Armor::onTrigger(%this,%obj,%slot,%val)
	{
		Parent::onTrigger(%this,%obj,%slot,%val);
		if(%slot == 4 && %val)
		{
			if(%obj.getMountedImage(0) == MP40Image.getID())
			{
				%obj.updateArm(MP40Image2);
				%obj.mountImage(MP40Image2,0);
			}
			else if(%obj.getMountedImage(0) == MP40Image2.getID())
			{
				%obj.updateArm(MP40Image2);
				%obj.mountImage(MP40Image,0);			
			}
		}
	}
};
activatePackage(imageSwitch);